## heaptrack 1.5.0+p24.04+vstable+git20251015.1233

=== CMakeLists.txt ===
if (CMAKE_VERSION VERSION_LESS "2.8.12")
    cmake_minimum_required(VERSION 2.8.9)
    set(HEAPTRACK_BUILD_GUI OFF)
elseif (CMAKE_VERSION VERSION_LESS "3.16.0")
    cmake_minimum_required(VERSION 2.8.12)
else()
    cmake_minimum_required(VERSION 3.16.0)
endif()

project(heaptrack)
enable_testing()

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build." FORCE)
endif()

set(HEAPTRACK_VERSION_MAJOR 1)
set(HEAPTRACK_VERSION_MINOR 6)
set(HEAPTRACK_VERSION_PATCH 0)
set(HEAPTRACK_LIB_VERSION 1.6.0)
set(HEAPTRACK_LIB_SOVERSION 2)
set(HEAPTRACK_FILE_FORMAT_VERSION 3)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(APPIMAGE_BUILD "configure build for bundling in an appimage" OFF)

set(REQUIRED_IN_APPIMAGE "")
if (APPIMAGE_BUILD)
    set(REQUIRED_IN_APPIMAGE REQUIRED)
endif()

include(FeatureSummary)
find_package(Boost 1.60.0 ${REQUIRED_IN_APPIMAGE} COMPONENTS system filesystem iostreams container)
set_package_properties(Boost PROPERTIES TYPE RECOMMENDED PURPOSE "Boost container libraries can greatly improve performance (via pmr allocators)")
find_package(Threads REQUIRED)
find_package(ZLIB REQUIRED)

if (${Boost_IOSTREAMS_FOUND})
    find_package(ZSTD ${REQUIRED_IN_APPIMAGE})

    include(CheckCXXSourceCompiles)
    include(CMakePushCheckState)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
    set(CMAKE_REQUIRED_LIBRARIES ${Boost_LIBRARIES})
    check_cxx_source_compiles("#include <boost/iostreams/filter/zstd.hpp>
        int main() { boost::iostreams::zstd_decompressor(); return 0; }"
        BOOST_IOSTREAMS_HAS_ZSTD
    )
    cmake_pop_check_state()
endif()
set_package_properties(ZSTD PROPERTIES TYPE RECOMMENDED PURPOSE "Zstandard offers better (de)compression performance compared with gzip/zlib, making heaptrack faster and datafiles smaller.")

if (CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    set(HEAPTRACK_BUILD_TRACK_DEFAULT ON)
    set(HEAPTRACK_BUILD_INTERPRET_DEFAULT ON)
else()
    set(HEAPTRACK_BUILD_TRACK_DEFAULT OFF)
    set(HEAPTRACK_BUILD_INTERPRET_DEFAULT OFF)
endif()

option(
  HEAPTRACK_BUILD_TRACK
  "Disable this option to skip building the tracker part for heaptrack, e.g. to only build the GUI."
  ${HEAPTRACK_BUILD_TRACK_DEFAULT}
)

option(
  HEAPTRACK_BUILD_INTERPRET
  "Disable this option to skip building the interpret part for heaptrack."
  ${HEAPTRACK_BUILD_INTERPRET_DEFAULT}
)

if (CMAKE_CROSSCOMPILING)
    set(HEAPTRACK_BUILD_ANALYZE_DEFAULT OFF)
else()
    set(HEAPTRACK_BUILD_ANALYZE_DEFAULT ON)
endif()

option(
  HEAPTRACK_BUILD_PRINT
  "Disable this option to skip building heaptrack_print, e.g. when you're cross-compiling."
  ${HEAPTRACK_BUILD_ANALYZE_DEFAULT}
)

option(
  HEAPTRACK_BUILD_GUI
  "Disable this option to skip building the Qt / KDE Frameworks based GUI for heaptrack."
  ${HEAPTRACK_BUILD_ANALYZE_DEFAULT}
)

option(
  HEAPTRACK_USE_QT6
  "Use Qt6/KF6 when building the Qt / KDE Frameworks based GUI for heaptrack."
  ON
)
if(HEAPTRACK_USE_QT6)
    set(QT_VERSION_MAJOR 6)
    # possibly works with older Qt6, but I didn't test that yet
    set(QT_MIN_VERSION 6.5.0)
else()
    set(QT_VERSION_MAJOR 5)
    set(QT_MIN_VERSION 5.10.0)
endif()

option(
  HEAPTRACK_USE_LIBUNWIND
  "Define preferred unwind functionality - Libunwind as ON and unwind_tables as OFF."
  ON
)

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

if (NOT MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic -Werror=undef -Werror=return-type")
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

include (CheckCXXSourceCompiles)

# cfree() does not exist in glibc 2.26+.
# See: https://bugs.kde.org/show_bug.cgi?id=383889
include(CheckSymbolExists)
check_symbol_exists(cfree malloc.h HAVE_CFREE)
check_symbol_exists(valloc stdlib.h HAVE_VALLOC)

set(BIN_INSTALL_DIR "bin")
set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")
set(LIBEXEC_INSTALL_DIR "${LIB_INSTALL_DIR}/heaptrack/libexec")

file(RELATIVE_PATH LIBEXEC_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIBEXEC_INSTALL_DIR}")

file(RELATIVE_PATH LIB_REL_PATH
    "${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}"
    "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}/heaptrack")

set(ECM_ENABLE_SANITIZERS "" CACHE STRING "semicolon-separated list of sanitizers to enable for code that is not injected into client applications")

if (ECM_ENABLE_SANITIZERS)
    find_package(ECM 1.0.0 NO_MODULE)
    if (ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})
    endif()
endif()

if (HEAPTRACK_BUILD_TRACK)
    if (HEAPTRACK_USE_LIBUNWIND)
        find_package(Libunwind REQUIRED)
    endif()

    check_cxx_source_compiles(
        "#ifdef __linux__
        #include <stdio_ext.h>
        #endif
        #include <fcntl.h>
        #include <dlfcn.h>
        #include <link.h>
        int main() { return 0; }"
        HAVE_LINUX_HEADERS)

    if (NOT HAVE_LINUX_HEADERS)
        message(FATAL_ERROR "You are missing some Linux/BSD headers required to compile heaptrack.")
    endif()
endif()

add_subdirectory(3rdparty)
add_subdirectory(src)
add_subdirectory(tests)

# Let releaseme know about this:
# SKIP_PO_INSTALL
# (KF5I18n is optional in src/analyze/CMakeLists.txt...)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

add_subdirectory(util)

if (HEAPTRACK_BUILD_TRACK)
    add_subdirectory(track)
endif()

if (HEAPTRACK_BUILD_INTERPRET)
    add_subdirectory(interpret)
endif()

if (HEAPTRACK_BUILD_PRINT OR HEAPTRACK_BUILD_GUI)
    add_subdirectory(analyze)
endif()

=== src/analyze/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

find_package(Boost 1.41.0 REQUIRED COMPONENTS iostreams program_options system filesystem)

configure_file(analyze_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/analyze_config.h)

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/3rdparty/
    ${CMAKE_CURRENT_BINARY_DIR}
)

add_library(sharedprint STATIC
    accumulatedtracedata.cpp
    suppressions.cpp
)

target_link_libraries(sharedprint
    PUBLIC
        ${Boost_LIBRARIES}
        ${ZLIB_LIBRARIES}
        tsl::robin_map
)

if (ZSTD_FOUND AND NOT BOOST_IOSTREAMS_HAS_ZSTD)
    target_link_libraries(sharedprint LINK_PUBLIC
        boost-zstd
    )
endif()

add_subdirectory(print)

if(HEAPTRACK_BUILD_GUI)
    if(QT_VERSION_MAJOR EQUAL 6)
        set(KChartName KChart6)
    else()
        set(KChartName KChart)
    endif()

    find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} ${REQUIRED_IN_APPIMAGE} NO_MODULE OPTIONAL_COMPONENTS Widgets)
    set_package_properties(Qt${QT_VERSION_MAJOR} PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable.")
    find_package(ECM 1.0.0 ${REQUIRED_IN_APPIMAGE} NO_MODULE)
    set_package_properties(ECM PROPERTIES TYPE RECOMMENDED PURPOSE "KDE's extra-cmake-modules, required for the heaptrack_gui executable.")
    if(Qt${QT_VERSION_MAJOR}_FOUND AND ECM_FOUND)
        set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})
            find_package(KF${QT_VERSION_MAJOR} ${REQUIRED_IN_APPIMAGE} COMPONENTS CoreAddons I18n ThreadWeaver ConfigWidgets KIO IconThemes)
            find_package(${KChartName} ${REQUIRED_IN_APPIMAGE} "2.6.0")
            set_package_properties(${KChartName} PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the heaptrack_gui executable. Get it from the kdiagram module.")
        if(KF${QT_VERSION_MAJOR}I18n_FOUND)
            ki18n_install(../../po)
        endif()
    else()
        message(WARNING "Required Qt/KF dependencies for building heaptrack GUI not found")
    endif()
endif()

if(KChart6_FOUND)
    set(KChart_FOUND TRUE)
endif()

if (KF${QT_VERSION_MAJOR}_FOUND)
    add_subdirectory(gui)
endif()

=== tests/auto/CMakeLists.txt ===

set(CMAKE_BUILD_TYPE Debug)
configure_file(tst_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/tst_config.h @ONLY)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src
    ${CMAKE_CURRENT_BINARY_DIR}/../../src/
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/track
)

if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
    if (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
        set(LIBUTIL_LIBRARY "util")
    endif()

    include_directories(
        ${Boost_INCLUDE_DIRS}
    )
endif()

# tst_inject isn't asan-safe, so include it before we enable sanitizers
add_subdirectory(no_asan)

if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

add_executable(tst_trace tst_trace.cpp ../../src/interpret/dwarfdiecache.cpp ../../src/interpret/demangler.cpp)
set_target_properties(tst_trace PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
target_link_libraries(tst_trace
    PRIVATE
        heaptrack_unwind
        Threads::Threads
        ${LIBDW_LIBRARIES}
        tsl::robin_map
)
target_include_directories(tst_trace PRIVATE ${LIBDW_INCLUDE_DIRS} )

add_test(NAME tst_trace COMMAND tst_trace)

configure_file(tst_heaptrack_interpret.cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/tst_heaptrack_interpret.sh @ONLY)
add_test(NAME tst_heaptrack_interpret COMMAND ${CMAKE_CURRENT_BINARY_DIR}/tst_heaptrack_interpret.sh)

if ("${Boost_FILESYSTEM_FOUND}" AND "${Boost_SYSTEM_FOUND}")
    add_executable(tst_libheaptrack
        tst_libheaptrack.cpp
        ../../src/track/libheaptrack.cpp)
    set_target_properties(tst_libheaptrack PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(tst_libheaptrack
        LINK_PRIVATE
            ${CMAKE_DL_LIBS}
            ${CMAKE_THREAD_LIBS_INIT}
            ${LIBUTIL_LIBRARY}
            heaptrack_unwind
            rt
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_libheaptrack COMMAND tst_libheaptrack)

    add_executable(tst_io tst_io.cpp)
    set_target_properties(tst_io PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
    target_link_libraries(tst_io
            ${Boost_SYSTEM_LIBRARY}
            ${Boost_FILESYSTEM_LIBRARY}
    )
    add_test(NAME tst_io COMMAND tst_io)

    if (TARGET heaptrack_gui_private)
        find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS Test)
        if (Qt${QT_VERSION_MAJOR}Test_FOUND)
            add_executable(tst_parser tst_parser.cpp)
            set_target_properties(tst_parser PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}")
            target_link_libraries(tst_parser
                    ${Boost_SYSTEM_LIBRARY}
                    ${Boost_FILESYSTEM_LIBRARY}
                    heaptrack_gui_private
                    Qt${QT_VERSION_MAJOR}::Test
            )
            add_test(NAME tst_parser COMMAND tst_parser)
        endif()
    endif()
endif()

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20251015.1233-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 12:33:44 +0000

=== debian/control ===
Source: heaptrack
Uploaders: Anton Gladky <gladk@debian.org>
Section: devel
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               elfutils,
               kf6-extra-cmake-modules,
               kf6-kconfigwidgets-dev,
               kf6-ki18n-dev,
               kf6-kio-dev,
               kf6-kitemmodels-dev,
               kf6-threadweaver-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libdw-dev,
               libdwarf-dev,
               libelf-dev,
               libkchart6-dev,
               libsparsehash-dev,
               libunwind-dev,
               libzstd-dev,
               qt6-base-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://github.com/KDE/heaptrack
Vcs-Git: https://invent.kde.org/neon/forks/heaptrack.git
Vcs-Browser: https://invent.kde.org/neon/forks/heaptrack
Maintainer: Neon CI <neon@kde.org>

Package: heaptrack
Architecture: any
Depends: libheaptrack (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the command line tools.

Package: heaptrack-gui
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the GUI for data analysis.

Package: libheaptrack
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: heap memory profiler for Linux
 Heap memory usage profiler. It uses LD_PRELOAD to track all calls
 to the core memory allocation functions and logs these occurrences.
 Additionally, backtraces are obtained and logged. It can also
 generate a historigram of allocation sizes over the number of
 calls. Heaptrack measures the following:
 .
   * Heap memory consumption (like Massif).
   * Number of calls to allocation functions (like callgrind).
   * Total amount of memory allocated, ignoring deallocations.
   * Leaked memory (like memcheck).
 .
 Heaptrack is notable for it's ability to attach to running processes,
 for consuming substantially less memory than Valgrind, and for not
 reducing an application's interactivity as much as Valgrind does.
 Heaptrack is useful for debugging memory leaks and memory ballooning.
 .
 The package contains the shared libraries.

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# # SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build
%:
	dh $@ --with kf6 --buildsystem kf6 --builddirectory=$(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- -DHEAPTRACK_BUILD_PRINT=ON -DHEAPTRACK_BUILD_GUI=ON -DHEAPTRACK_USE_QT6=ON

# Unittests are disabled on mips due to build failures
# It looks like the crash is happening in libunwind,
# needs to be investigated
#
# https://sources.debian.net/src/libunwind/1.1-4.1/debian/rules/#L34
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
ifneq (mips, $(DEB_BUILD_ARCH))
override_dh_auto_install:
	dh_auto_install
	cd $(BUILDDIR) ; $(MAKE) test ARGS=-VV
endif # amd64
endif # nocheck

override_dh_auto_test:

## heaptrack 1.5.0+p24.04+vstable+git20251018.2359

=== 3rdparty/CMakeLists.txt ===
if (ECM_FOUND)
    include(ECMEnableSanitizers)
endif()

# Mark the specified target's include directories as INTERFACE_SYSTEM_INCLUDE_DIRECTORIES
function(mark_as_system_target target)
    # see also: https://gitlab.kitware.com/cmake/cmake/-/issues/21211
    get_property(
        include_dirs
        TARGET ${target}
        PROPERTY INTERFACE_INCLUDE_DIRECTORIES
    )
    set_property(TARGET ${target} PROPERTY INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "${include_dirs}")
endfunction()

if (ZSTD_FOUND AND NOT BOOST_IOSTREAMS_HAS_ZSTD)
    add_subdirectory(boost-zstd)
    mark_as_system_target(boost-zstd)
endif()

add_subdirectory(robin-map)

mark_as_system_target(robin_map)

=== src/analyze/gui/CMakeLists.txt ===
set(CMAKE_AUTOMOC 1)

ki18n_wrap_ui(UIFILES
    mainwindow.ui
)

unset(BIN_INSTALL_DIR)
unset(LIB_INSTALL_DIR)
unset(LIBEXEC_INSTALL_DIR)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMAddTests)
include(ECMInstallIcons)
include(ECMAddAppIcon)

configure_file(gui_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/gui_config.h)

add_compile_options(-Wall)

add_definitions(-DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
)

add_library(heaptrack_gui_private STATIC
    util.cpp
    parser.cpp
)
target_link_libraries(heaptrack_gui_private PUBLIC
    KF${QT_VERSION_MAJOR}::I18n
    KF${QT_VERSION_MAJOR}::CoreAddons # KFormat
    KF${QT_VERSION_MAJOR}::ThreadWeaver
    Qt${QT_VERSION_MAJOR}::Core
    sharedprint
    pthread
    ${CMAKE_THREAD_LIBS_INIT}
)
if (BUILD_COVERAGE)
    # FIXME: this should be handled within ECM instead of workarounded here
    target_link_libraries(heaptrack_gui_private PRIVATE -lgcov)
endif()

target_compile_definitions(heaptrack_gui_private PRIVATE TRANSLATION_DOMAIN="heaptrack")

target_include_directories(heaptrack_gui_private PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${Boost_INCLUDE_DIRS}
)

set(SRCFILES
    gui.cpp
    mainwindow.cpp
    treemodel.cpp
    treeproxy.cpp
    costdelegate.cpp
    costheaderview.cpp
    flamegraph.cpp
    stacksmodel.cpp
    topproxy.cpp
    callercalleemodel.cpp
    proxystyle.cpp
    suppressionsmodel.cpp
    resources.qrc
)

ecm_add_app_icon(SRCFILES ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/128-heaptrack_app_icon.png
    ${CMAKE_CURRENT_SOURCE_DIR}/512-heaptrack_app_icon.png
)

set(LIBRARIES
    Qt${QT_VERSION_MAJOR}::Widgets
    KF${QT_VERSION_MAJOR}::ConfigWidgets
    KF${QT_VERSION_MAJOR}::I18n
    KF${QT_VERSION_MAJOR}::KIOWidgets
    KF${QT_VERSION_MAJOR}::IconThemes
    sharedprint
    heaptrack_gui_private
)

if (KChart_FOUND)
    list(APPEND SRCFILES
        chartwidget.cpp
        chartmodel.cpp
        chartproxy.cpp
        histogramwidget.cpp
        histogrammodel.cpp
    )
    list(APPEND LIBRARIES
        ${KChartName}
        Qt${QT_VERSION_MAJOR}::Svg
    )
endif()

add_executable(heaptrack_gui
    ${SRCFILES}
    ${UIFILES}
)

target_link_libraries(heaptrack_gui
    ${LIBRARIES}
)

install(TARGETS heaptrack_gui
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(heaptrack_gui PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${KDE_INSTALL_BINDIR}"
)

install(PROGRAMS org.kde.heaptrack.desktop
    DESTINATION ${KDE_INSTALL_APPDIR}
)

install(FILES org.kde.heaptrack.appdata.xml
    DESTINATION ${KDE_INSTALL_METAINFODIR}
)

ecm_install_icons(ICONS
  16-apps-heaptrack.png
  22-apps-heaptrack.png
  32-apps-heaptrack.png
  48-apps-heaptrack.png
  64-apps-heaptrack.png
  128-apps-heaptrack.png
  DESTINATION ${KDE_INSTALL_ICONDIR}
  THEME hicolor
)

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20251018.2359-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 18 Oct 2025 23:59:46 +0000

## heaptrack 1.5.0+p24.04+vstable+git20251231.0330

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20251231.0330-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 31 Dec 2025 03:30:41 +0000

## heaptrack 1.5.0+p24.04+vstable+git20260103.0401

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20260103.0401-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 03 Jan 2026 04:01:50 +0000

## heaptrack 1.5.0+p24.04+vstable+git20260121.0151

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20260121.0151-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 21 Jan 2026 01:51:51 +0000

heaptrack (1.5.0) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:24:09 +0000

## heaptrack 1.5.0+p24.04+vstable+git20260131.1328

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vstable+git20260131.1328-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 31 Jan 2026 13:28:54 +0000

=== debian/watch ===
version=4
# https://download.kde.org/stable/heaptrack/([\d.]+)/@PACKAGE@-([\d.]+)\.tar\.xz
https://download.kde.org/Attic/heaptrack/([\d.]+)/@PACKAGE@-([\d.]+)\.tar\.xz

## heaptrack 1.5.0+p24.04+vunstable+git20251020.1240

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vunstable+git20251020.1240-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 12:40:40 +0000

## heaptrack 1.5.0+p24.04+vunstable+git20251110.1223

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vunstable+git20251110.1223-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 10 Nov 2025 12:24:07 +0000

## heaptrack 1.5.0+p24.04+vunstable+git20260121.0151

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vunstable+git20260121.0151-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 21 Jan 2026 01:51:51 +0000

=== debian/control ===
--- 
+++ 
@@ -1,4 +1,5 @@
 Source: heaptrack
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Anton Gladky <gladk@debian.org>
 Section: devel
 Priority: optional
@@ -11,6 +12,7 @@
                kf6-kio-dev,
                kf6-kitemmodels-dev,
                kf6-threadweaver-dev,
+               libboost-container-dev,
                libboost-filesystem-dev,
                libboost-iostreams-dev,
                libboost-program-options-dev,
@@ -20,6 +22,7 @@
                libdwarf-dev,
                libelf-dev,
                libkchart6-dev,
+               librust-rustc-demangle-dev,
                libsparsehash-dev,
                libunwind-dev,
                libzstd-dev,
@@ -46,7 +49,7 @@
    * Total amount of memory allocated, ignoring deallocations.
    * Leaked memory (like memcheck).
  .
- Heaptrack is notable for it's ability to attach to running processes,
+ Heaptrack is notable for its ability to attach to running processes,
  for consuming substantially less memory than Valgrind, and for not
  reducing an application's interactivity as much as Valgrind does.
  Heaptrack is useful for debugging memory leaks and memory ballooning.
@@ -68,7 +71,7 @@
    * Total amount of memory allocated, ignoring deallocations.
    * Leaked memory (like memcheck).
  .
- Heaptrack is notable for it's ability to attach to running processes,
+ Heaptrack is notable for its ability to attach to running processes,
  for consuming substantially less memory than Valgrind, and for not
  reducing an application's interactivity as much as Valgrind does.
  Heaptrack is useful for debugging memory leaks and memory ballooning.
@@ -90,7 +93,7 @@
    * Total amount of memory allocated, ignoring deallocations.
    * Leaked memory (like memcheck).
  .
- Heaptrack is notable for it's ability to attach to running processes,
+ Heaptrack is notable for its ability to attach to running processes,
  for consuming substantially less memory than Valgrind, and for not
  reducing an application's interactivity as much as Valgrind does.
  Heaptrack is useful for debugging memory leaks and memory ballooning.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # SPDX-License-Identifier: LGPL-2.0-or-later
 # # SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>
 
-#!/usr/bin/make -f
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
 BUILDDIR = $(CURDIR)/debian/build
 %:
 	dh $@ --with kf6 --buildsystem kf6 --builddirectory=$(BUILDDIR)

## heaptrack 1.5.0+p24.04+vunstable+git20260131.0122

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,4 @@
-if (CMAKE_VERSION VERSION_LESS "2.8.12")
-    cmake_minimum_required(VERSION 2.8.9)
-    set(HEAPTRACK_BUILD_GUI OFF)
-elseif (CMAKE_VERSION VERSION_LESS "3.16.0")
-    cmake_minimum_required(VERSION 2.8.12)
-else()
-    cmake_minimum_required(VERSION 3.16.0)
-endif()
+cmake_minimum_required(VERSION 3.16.0)
 
 project(heaptrack)
 enable_testing()
@@ -17,8 +10,8 @@
 
 set(HEAPTRACK_VERSION_MAJOR 1)
 set(HEAPTRACK_VERSION_MINOR 6)
-set(HEAPTRACK_VERSION_PATCH 0)
-set(HEAPTRACK_LIB_VERSION 1.6.0)
+set(HEAPTRACK_VERSION_PATCH 80)
+set(HEAPTRACK_LIB_VERSION 1.6.80)
 set(HEAPTRACK_LIB_SOVERSION 2)
 set(HEAPTRACK_FILE_FORMAT_VERSION 3)
 
@@ -32,12 +25,12 @@
 endif()
 
 include(FeatureSummary)
-find_package(Boost 1.60.0 ${REQUIRED_IN_APPIMAGE} COMPONENTS system filesystem iostreams container)
+find_package(Boost 1.70.0 CONFIG ${REQUIRED_IN_APPIMAGE} COMPONENTS filesystem iostreams container)
 set_package_properties(Boost PROPERTIES TYPE RECOMMENDED PURPOSE "Boost container libraries can greatly improve performance (via pmr allocators)")
 find_package(Threads REQUIRED)
 find_package(ZLIB REQUIRED)
 
-if (${Boost_IOSTREAMS_FOUND})
+if (Boost_IOSTREAMS_FOUND)
     find_package(ZSTD ${REQUIRED_IN_APPIMAGE})
 
     include(CheckCXXSourceCompiles)
@@ -91,19 +84,8 @@
   ${HEAPTRACK_BUILD_ANALYZE_DEFAULT}
 )
 
-option(
-  HEAPTRACK_USE_QT6
-  "Use Qt6/KF6 when building the Qt / KDE Frameworks based GUI for heaptrack."
-  ON
-)
-if(HEAPTRACK_USE_QT6)
-    set(QT_VERSION_MAJOR 6)
-    # possibly works with older Qt6, but I didn't test that yet
-    set(QT_MIN_VERSION 6.5.0)
-else()
-    set(QT_VERSION_MAJOR 5)
-    set(QT_MIN_VERSION 5.10.0)
-endif()
+# possibly works with older Qt6, but I didn't test that yet
+set(QT_MIN_VERSION 6.5.0)
 
 option(
   HEAPTRACK_USE_LIBUNWIND

=== debian/changelog ===
heaptrack (1.5.0+p24.04+vunstable+git20260131.0122-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 31 Jan 2026 01:22:35 +0000
